<div id="wrapper">
  <div class="d-flex flex-column" id="content-wrapper">
    <div id="content">
      <app-nav></app-nav>

      <div class="modal fade" role="dialog" tabindex="-1" id="modal-details">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <form #taskForm="ngForm" (ngSubmit)="taskForm.form.valid && saveTask()">
              <div class="modal-header">
                <h4 class="modal-title">Detalles de la tarea</h4>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
              </div>
              <div class="modal-body">
                <input class="border rounded-pill form-control"
                       type="text"
                       id="taskName"
                       name="taskName"
                       placeholder="Nombre de la tarea"
                       [(ngModel)]="currentTask.taskName"
                       minlength="2"
                       maxlength="100"
                       required
                       style="margin: 0 0 1em 0;">
                <textarea class="border rounded form-control"
                          id="description"
                          name="description"
                          placeholder="Description"
                          minlength="5"
                          maxlength="300"
                          required
                          [(ngModel)]="currentTask.description"
                          style="margin: 0 0 1em 0;"></textarea>
              </div>
              <div class="modal-footer">
                <button class="btn btn-light" type="button" data-bs-dismiss="modal">Cerrar</button>
                <button class="btn"
                        [ngClass]="{'btn-primary': taskForm.form.valid, 'btn-secondary': !taskForm.form.valid}"
                        type="submit" data-bs-dismiss="modal">Guardar
                </button>
              </div>
            </form>
          </div>
        </div>
      </div>

      <div class="modal fade" role="dialog" tabindex="-1" id="modal-confirmation">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h4 class="modal-title">Eliminar tarea</h4>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
              <p>¿Realmente desea eliminar la tarea {{currentTask.taskName}}?</p>
            </div>
            <div class="modal-footer">
              <button class="btn btn-light" type="button" data-bs-dismiss="modal">Cancelar</button>
              <button class="btn btn-danger" type="button" (click)="deleteTask()" data-bs-dismiss="modal">Eliminar
              </button>
            </div>
          </div>
        </div>
      </div>

      <div class="container-fluid">
        <div class="d-sm-flex justify-content-between align-items-center mb-4">
          <h3 class="text-dark mb-0">Tablero kanban</h3>
        </div>
        <div class="row">

          <div *ngFor="let state of states" class="col-lg-6 mb-4">
            <div class="card shadow mb-4">
              <div class="card-header py-3">
                <div class="row">
                  <div class="col">
                    <h4 class="text-info fw-bold m-0">{{state.stateName | titlecase}}</h4>
                  </div>
                  <div class="col text-end">
                    <button class="btn btn-primary"
                            type="button"
                            style="border-radius: 15px;"
                            data-bs-target="#modal-details"
                            (click)="setCurrentState(state);resetCurrentTask()"
                            data-bs-toggle="modal">+
                    </button>
                  </div>
                </div>
              </div>
              <div *ngIf="getTasksByState(state).length > 0; else emptyTasks">
                <div *ngFor="let task of getTasksByState(state)" class="card-body border rounded-0 border-light">
                  <div class="row">
                    <div class="col">
                      <h5>{{task.taskName}}</h5>
                    </div>
                    <div class="col" style="text-align: right;">
                      <div class="dropdown">
                        <button class="btn btn-primary btn-sm dropdown-toggle border rounded-pill" aria-expanded="false"
                                data-bs-toggle="dropdown" type="button"
                                style="margin: 0 0 10px 0;">{{task.stateTask | titlecase}}
                        </button>
                        <div class="dropdown-menu"><a *ngFor="let state of getStates(task.stateTask)"
                                                      class="dropdown-item" (click)="changeState(task, state)"
                        >{{state.stateName | titlecase}}</a>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div class="row align-items-center no-gutters">
                    <div class="col col-10">
                      <div class="text-dark fw-bold h5 mb-0"><span style="font-size: 0.8em;">{{task.description}}</span>
                      </div>
                    </div>
                    <div class="col col-2" style="text-align: right;">
                      <i class="fas fa-trash btn"
                         (click)="setCurrentTask(task)"
                         data-bs-target="#modal-confirmation"
                         data-bs-toggle="modal"></i>
                      <i class="fa fa-pencil btn"
                         data-bs-target="#modal-details"
                         data-bs-toggle="modal"
                         (click)="setCurrentTask(task);setCurrentState(state)"></i>
                    </div>
                  </div>
                  <span>{{task.updateDate.toString() | timeAgo}}</span>
                </div>
              </div>
              <ng-template #emptyTasks>
                <div class="card-body border rounded-0 border-light">
                  No hay tareas asignadas.
                </div>
              </ng-template>
            </div>
          </div>

        </div>
      </div>
    </div>
    <app-footer></app-footer>
  </div>
</div>
